ansible: Disable multilib for gcc 4.8 powerpc64le
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
447eaf93
KS
21platforms=${platforms:-}
22# Derive arch from label if it isn't set
23if [ -z "${arch:-}" ] ; then
24 # Labels may be platform specific, eg. jammy-amd64, deb12-armhf
25 regex='[[:alnum:]]+-([[:alnum:]]+)'
26 if [[ "${platforms}" =~ ${regex} ]] ; then
27 arch="${BASH_REMATCH[1]}"
28 else
29 arch="${platforms:-}"
30 fi
31fi
39961776
MJ
32cross_arch=${cross_arch:-}
33ktag=${ktag:-}
5a196804
MJ
34kgitrepo=${kgitrepo:-}
35mversion=${mversion:-}
36mgitrepo=${mgitrepo:-}
39961776 37
339db64d
MJ
38## FUNCTIONS ##
39
f3d8604b
MJ
40# Kernel version compare functions
41verlte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
43}
44
45verlt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
48}
49
50vergte() {
51fa2ab3 51 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
52}
53
54vergt() {
28b10e79 55 # shellcheck disable=SC2015
51fa2ab3 56 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
57}
58
339db64d 59
5a196804
MJ
60git_clone_modules_sources() {
61 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
62
63 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
64 # as a branch name.
65 if [ "${mversion:0:5}" = "refs/" ]; then
66 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
67 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
68 else
69 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
70 fi
5a196804
MJ
71}
72
73# Checkout a shallow kernel tree of the specified tag
74git_clone_linux_sources() {
75 mkdir -p "$LINUX_GIT_DIR"
76 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
77}
7e02032c 78
7e02032c 79
5a196804
MJ
80# Export the kernel sources from the git repo
81git_export_linux_sources() {
82 cd "$LINUX_GIT_DIR"
83 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
84}
85
86
87# Upload the tar archive to the object store
88upload_archive_obj() {
89 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
90 rm -f "$WORKSPACE/$obj_name"
91}
92
93
94extract_archive_obj() {
95 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
96 rm -f "$WORKSPACE/$obj_name"
97}
98
99
100tar_archive_obj() {
101 cd "$LINUX_OBJ_DIR"
102 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
103 cd -
104}
105
6c0b2710
KS
106list_gccs() {
107 local gccs
108 gccs=()
109 IFS=: read -r -a path_array <<< "$PATH"
110 while read -r gcc ; do
111 gccs+=("$gcc")
112 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
113 echo "${gccs[@]}"
114}
115
5a196804
MJ
116# Find the most recent GCC version supported by the kernel sources
117select_compiler() {
118 local selected_cc
119
120 cd "$LINUX_SRCOBJ_DIR"
121
122 kversion=$(make -s kernelversion)
123
124 set +e
125
6c0b2710 126 for cc in $(list_gccs) ; do
5a196804
MJ
127 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
128 selected_cc="$cc"
129 break
130 fi
131 done
132
133 set -e
134
135 if [ "x$selected_cc" = "x" ]; then
136 echo "Found no suitable compiler."
137 exit 1
138 fi
139
1d5a0a3c
MJ
140 # Force gcc-4.8 for kernels before 3.18
141 if { verlt "$kversion" "3.18"; }; then
23db2292 142 selected_cc=gcc-4.8
7e02032c
MJ
143 fi
144
425e4992
MJ
145 if [ "$selected_cc" != "gcc-4.8" ]; then
146 # Older kernel Makefiles do not expect the compiler to default to PIE
147 KAFLAGS="-fno-pie"
c45b04df 148 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
149 KCPPFLAGS="-fno-pie"
150 export KAFLAGS KCFLAGS KCPPFLAGS
151 fi
152
5a196804 153 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 154 export HOSTCC="${selected_cc}"
5a196804
MJ
155
156 cd -
157}
158
159
160build_linux_kernel() {
161 cd "$LINUX_SRCOBJ_DIR"
162
163 kversion=$(make -s kernelversion)
164
7e02032c 165 # Generate kernel configuration
a1ae361e 166 case "$ktag" in
7e02032c 167 Ubuntu*)
39961776 168 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 169 if vergte "${kversion}" "4.10"; then
39961776
MJ
170 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
171 exit 0
172 fi
173 fi
af101606
MJ
174
175 # Disable riscv64 config generation, we don't have a toolchain on bionic
176 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
177
0c1bde3d
KS
178 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
179
073dc82c 180 # Hack for kernel Ubuntu-hwe-5.8
0c1bde3d
KS
181 # The debian/control file is produced by the clean target above, so this
182 # check needs to happen afterwards.
183 if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
073dc82c
MJ
184 echo "10" > "debian/compat"
185 fi
186
0c1bde3d
KS
187 # genconfigs check can fail in certain cases, eg. when a more recent
188 # compiler exposes kernel configuration flags which aren't set in the
189 # Ubuntu annotations.
190 # In any case, the configuration will be updated with any missing values
191 # later in our build script.
192 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
5a196804 193 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 194 ;;
c45b04df 195
7e02032c 196 *)
16844a6d
MJ
197 # Force 32bit build on i386, default is 64bit
198 if [ "$arch" = "i386" ]; then
5a196804
MJ
199 export ARCH="i386"
200 fi
201
5a196804 202 make "${vanilla_config}"
7e02032c
MJ
203 ;;
204 esac
205
53b51a15 206 # oldnoconfig was renamed in 4.19
5a196804 207 if vergte "$kversion" "4.19"; then
53b51a15 208 update_conf_target="olddefconfig"
5a196804 209 else
53b51a15 210 update_conf_target="oldnoconfig"
5a196804
MJ
211 fi
212
213 # Fix 'defined(@array)' was removed from recent perl
214 if [ -f "kernel/timeconst.pl" ]; then
215 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
216 fi
217
218 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 219 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
220 if [ -f "arch/x86/kvm/svm.c" ]; then
221 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
222 fi
223
224 if [ -f "arch/x86/kvm/vmx.c" ]; then
225 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
226 fi
227 fi
228
53b51a15
MJ
229 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
230 # Convert them to 'cmpw' which was previously done silently
231 if verlt "$kversion" "4.9"; then
232 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
233 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
234 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
235 fi
236
5a196804
MJ
237 # Fix a typo in v2.6.36.x
238 if [ -f "arch/x86/kernel/entry_64.S" ]; then
239 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
240 fi
241
53b51a15
MJ
242 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
243 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
244 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
245 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
246 fi
247
5a196804
MJ
248 # Fix kernel < 3.0 with gcc >= 4.7
249 if verlt "$kversion" "3.0"; then
250 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
251 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
252 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
253 echo "header-y += linkage.h" >> include/linux/Kbuild
254 fi
255
7e02032c 256 # GCC 4.8
53b51a15
MJ
257 if [ "$HOSTCC" == "gcc-4.8" ]; then
258 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
259 fi
7e02032c
MJ
260
261 # Don't try to sign modules
53b51a15 262 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 263
9ef18fa2 264 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 265 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
266
267 # Cause problems with inline assembly on i386
53b51a15 268 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 269
1d5a0a3c 270 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
271 scripts/config --disable CONFIG_SAMPLES
272 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
273
274 # Disable kcov
53b51a15 275 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
276
277 # Broken on some RT kernels
53b51a15 278 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 279
1e300ea9 280 # Broken drivers
53b51a15
MJ
281 scripts/config --disable CONFIG_RAPIDIO_TSI721
282 scripts/config --disable CONFIG_SGI_XP
283 scripts/config --disable CONFIG_MFD_WM8994
284 scripts/config --disable CONFIG_DRM_RADEON
285 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 286
5a196804
MJ
287 # IGBVF won't build with recent gcc on 2.6.38.x
288 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 289 scripts/config --disable CONFIG_IGBVF
5a196804 290 fi
9ef18fa2 291
c72041eb
MJ
292 # Don't fail the build on warnings
293 scripts/config --disable CONFIG_WERROR
294
51fa2ab3 295 # Set required options
53b51a15
MJ
296 scripts/config --enable CONFIG_TRACEPOINTS
297 scripts/config --enable CONFIG_KALLSYMS
298 scripts/config --enable CONFIG_HIGH_RES_TIMERS
299 scripts/config --enable CONFIG_KPROBES
300 scripts/config --enable CONFIG_FTRACE
301 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
302 scripts/config --enable CONFIG_KALLSYMS_ALL
303 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
304 scripts/config --enable CONFIG_PERF_EVENTS
305 scripts/config --enable CONFIG_EVENT_TRACING
306 scripts/config --enable CONFIG_KRETPROBES
7e02032c 307
7a76a4d0 308 # Debug
5a196804
MJ
309 #cat .config
310
311 make "$update_conf_target" CC="$CC"
312 make -j"$NPROC" CC="$CC"
313
c45b04df 314 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
315
316 # Save the kernel and modules
317 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 318 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 319 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
320 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
321 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
322 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
323}
324
325
326extract_distro_headers() {
327
328 # Enter linux source dir
329 cd "${LINUX_SRCOBJ_DIR}"
330
331
332 # For RT kernels, copy version file
333 if [ -s localversion-rt ]; then
334 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
335 fi
336
337 # Copy all Makefile related stuff
338 find . -path './include/*' -prune \
339 -o -path './scripts/*' -prune -o -type f \
340 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
341 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
342 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
343
344 # Copy base scripts and include dirs
345 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 346
5a196804
MJ
347 # Copy arch includes
348 (find arch -name include -type d -print0 | \
349 xargs -0 -n1 -i: find : -type f) | \
350 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
351
352 # Copy arch scripts
353 (find arch -name scripts -type d -print0 | \
354 xargs -0 -n1 -i: find : -type f) | \
355 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
356
357 # Cleanup scripts
358 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
359 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
360
04873cc3 361 # On powerpc 32bits this object is required to link modules
5a196804 362 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
363 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
364 :
365 else
04873cc3
MJ
366 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
367 fi
5a196804
MJ
368 fi
369
370 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
371 if [ "${karch}" = "arm64" ]; then
372 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
373 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
374 fi
375 fi
376
377 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
378 if [ -f tools/objtool/objtool ]; then
379 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
380 fi
381
382 if [ -f "arch/x86/kernel/macros.s" ]; then
383 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
384 fi
385
386 # Copy modules related stuff, if available
387 if [ -s Module.symvers ]; then
388 cp Module.symvers "${LINUX_HDROBJ_DIR}"
389 fi
390
391 if [ -s System.map ]; then
392 cp System.map "${LINUX_HDROBJ_DIR}"
393 fi
394
395 if [ -s Module.markers ]; then
396 cp Module.markers "${LINUX_HDROBJ_DIR}"
397 fi
398
399 # Copy config file
400 cp .config "${LINUX_HDROBJ_DIR}"
401
402 # Make sure the Makefile and version.h have a matching timestamp so that
403 # external modules can be built
404 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
405 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
406 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
407 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
408 else
409 echo "Missing version.h"
410 exit 1
411 fi
412 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
413
414 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
780f6285
MJ
415 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
416 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
417 fi
5a196804
MJ
418
419 # Finally clean the object files from the full source tree
420 make clean
421
422 # And regen the modules support files
423 make modules_prepare CC="$CC"
51fa2ab3 424
04873cc3 425 # On powerpc 32bits this object is required to link modules
d815b018 426 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
427 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
428 :
429 else
04873cc3
MJ
430 make arch/powerpc/lib/crtsavres.o CC="$CC"
431 fi
d815b018
MJ
432 fi
433
7a76a4d0 434 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 435 if [ "${karch}" = "arm64" ]; then
c236528e 436 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 437 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
438 fi
439 fi
440
7e02032c 441 # Version specific tasks
a1ae361e 442 case "$ktag" in
7e02032c
MJ
443 Ubuntu*)
444 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 445 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
446 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
447 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
448 ;;
449 esac
7e02032c
MJ
450}
451
452
339db64d
MJ
453build_modules() {
454
5a196804
MJ
455 local kdir="$1"
456 local outdir="$2"
457 local kversion
458
459 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 460
2456f978
MJ
461 # Try to catch some compatibility problems by turning some
462 # warnings into errors.
999a2aa0 463 #export KCFLAGS="$KCFLAGS -Wall -Werror"
2456f978 464
339db64d 465 # Enter lttng-modules source dir
5a196804 466 cd "${MODULES_GIT_DIR}"
339db64d
MJ
467
468 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
469 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
470 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
471 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
472
473 set +e
474
475 # Build modules
51fa2ab3 476 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 477 ret=$?
339db64d 478
5a196804
MJ
479 set -e
480
339db64d 481 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 482 if [ "$ret" -eq 0 ]; then
e9b44189 483 echo "This build should have failed."
339db64d
MJ
484 exit 1
485 fi
486
487 # We have to publish at least one file or the build will fail
5a196804 488 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 489
5a196804 490 KERNELDIR="${kdir}" make clean
7e02032c 491
339db64d
MJ
492 else # Regular build
493
494 # Build modules against full kernel sources
51fa2ab3 495 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
496
497 # Install modules to build dir
5a196804 498 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
499
500 # Clean build dir
5a196804 501 KERNELDIR="${kdir}" make clean
339db64d
MJ
502 fi
503}
504
505
506## MAIN ##
507
f3d8604b
MJ
508# Use all CPU cores
509NPROC=$(nproc)
510
5a196804
MJ
511MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
512LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 513
5a196804
MJ
514LINUX_OBJ_DIR="${WORKSPACE}/linux"
515LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
516LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
517LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 518
5a196804
MJ
519MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
520MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 521
5a196804
MJ
522LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
523
524OBJ_STORE_URL="s3://jenkins"
525
526cd "$WORKSPACE"
527
528# Create build directories
529mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
530
531git_clone_modules_sources
339db64d 532
7e02032c 533# Setup cross compile env if available
39961776 534if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
535
536 case "$cross_arch" in
537 "armhf")
538 karch="arm"
539 cross_compile="arm-linux-gnueabihf-"
53b51a15 540 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
541 ubuntu_config="armhf-config.flavour.generic"
542 ;;
543
544 "arm64")
545 karch="arm64"
546 cross_compile="aarch64-linux-gnu-"
53b51a15 547 vanilla_config="defconfig"
7e02032c
MJ
548 ubuntu_config="arm64-config.flavour.generic"
549 ;;
550
551 "powerpc")
552 karch="powerpc"
553 cross_compile="powerpc-linux-gnu-"
e9b44189 554 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
555 ubuntu_config="powerpc-config.flavour.powerpc-smp"
556 ;;
557
558 "ppc64el")
559 karch="powerpc"
560 cross_compile="powerpc64le-linux-gnu-"
e9b44189 561 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
562 ubuntu_config="ppc64el-config.flavour.generic"
563 ;;
564
565 *)
51fa2ab3 566 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
567 exit 1
568 ;;
569 esac
339db64d 570
7e02032c
MJ
571 # Export variables used by Kbuild for cross compilation
572 export ARCH="${karch}"
573 export CROSS_COMPILE="${cross_compile}"
339db64d 574
7e02032c 575# Set arch specific values if we are not cross compiling
39961776 576elif [ "x${arch}" != "x" ]; then
e9b44189 577
7e02032c 578 case "$arch" in
16844a6d 579 "i386")
7e02032c 580 karch="x86"
1490b049 581 vanilla_config="allmodconfig"
7e02032c
MJ
582 ubuntu_config="i386-config.flavour.generic"
583 ;;
584
16844a6d 585 "amd64")
7e02032c 586 karch="x86"
1490b049 587 vanilla_config="allmodconfig"
7e02032c
MJ
588 ubuntu_config="amd64-config.flavour.generic"
589 ;;
590
591 "armhf")
592 karch="arm"
1490b049 593 vanilla_config="allmodconfig"
7e02032c
MJ
594 ubuntu_config="armhf-config.flavour.generic"
595 ;;
596
597 "arm64")
598 karch="arm64"
1490b049 599 vanilla_config="allmodconfig"
7e02032c
MJ
600 ubuntu_config="arm64-config.flavour.generic"
601 ;;
602
603 "powerpc")
604 karch="powerpc"
1490b049 605 vanilla_config="allmodconfig"
7e02032c
MJ
606 ubuntu_config="powerpc-config.flavour.powerpc-smp"
607 ;;
608
609 "ppc64el")
610 karch="powerpc"
1490b049 611 vanilla_config="allmodconfig"
7e02032c
MJ
612 ubuntu_config="ppc64el-config.flavour.generic"
613 ;;
614
615 *)
616 echo "Unsupported arch $arch"
617 exit 1
618 ;;
619 esac
620else
04873cc3 621 echo "No arch or cross_arch specified"
7e02032c
MJ
622 exit 1
623fi
339db64d 624
339db64d 625
b214d997 626
5a196804
MJ
627# First get the kernel build from the object store, or build it, if it's
628# not available.
339db64d 629
5a196804
MJ
630echo "# Setup endpoint
631host_base = obj.internal.efficios.com
632host_bucket = obj.internal.efficios.com
633bucket_location = us-east-1
634use_https = True
7e02032c 635
5a196804
MJ
636# Setup access keys
637access_key = jenkins
638secret_key = echo123456
339db64d 639
5a196804
MJ
640# Enable S3 v4 signature APIs
641signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 642
c45b04df 643url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 644obj_name="linux.tar.bz2"
87445931
MJ
645
646if [ "x${cross_arch}" = "x" ]; then
909c5352 647 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/$arch/native"
87445931 648else
909c5352 649 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/${cross_arch}"
87445931
MJ
650fi
651
5a196804 652obj_url="$obj_url_prefix/$obj_name"
339db64d 653
5a196804 654set +e
e18b6e95
KS
655# In s3cmd 2.3, the return code of get when an object does not exist (64)
656# is different than in 2.2 (12). The return codes of 's3cmd info' are
657# consistent between 2.2 and 2.3.
658s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
5a196804
MJ
659ret=$?
660set -e
339db64d 661
5a196804
MJ
662case "$ret" in
663 "0")
e18b6e95 664 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
5a196804
MJ
665 extract_archive_obj
666 ;;
a1ae361e 667
5a196804
MJ
668 "12")
669 echo "File not found"
339db64d 670
5a196804
MJ
671 # Build all the things and upload
672 # then finish the module build...
339db64d 673
5a196804
MJ
674 git_clone_linux_sources
675 git_export_linux_sources
339db64d 676
5a196804 677 select_compiler
a1ae361e 678
5a196804
MJ
679 ## PREPARE FULL LINUX SOURCE TREE
680 build_linux_kernel
d138fc44 681
5a196804
MJ
682 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
683 extract_distro_headers
339db64d 684
5a196804 685 tar_archive_obj
339db64d 686
5a196804 687 upload_archive_obj
339db64d 688
5a196804 689 ;;
339db64d 690
5a196804
MJ
691 *)
692 echo "Unknown error? Abort"
693 exit 1
694 ;;
695esac
339db64d 696
5a196804 697select_compiler
f3d8604b 698
7e02032c 699## BUILD modules
5a196804
MJ
700# Either we downloaded a pre-build kernel or we built it and uploaded
701# the archive for future builds.
702
703cd "$WORKSPACE"
f3d8604b 704
339db64d 705# Build modules against full kernel sources
5a196804 706build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 707
339db64d 708# Build modules against kernel headers
5a196804 709build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 710
5a196804
MJ
711# Make sure some modules were actually built
712tree "${MODULES_OUTPUT_KSRC_DIR}"
713if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
714 echo "No modules built!"
715 exit 1
716fi
717
5a196804
MJ
718tree "${MODULES_OUTPUT_KHDR_DIR}"
719if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
720 echo "No modules built!"
721 exit 1
722fi
b214d997 723
f3d8604b 724# EOF
This page took 0.065989 seconds and 4 git commands to generate.